=== sql/CMakeLists.txt ===
if(mysql)
  add_subdirectory(mysql)
endif()
if(oracle)
  add_subdirectory(oracle)
endif()
if(odbc)
  add_subdirectory(odbc)
endif()
if(pgsql)
  add_subdirectory(pgsql)
endif()
