=== debian/changelog ===
root-system (5.34.09-1) unstable; urgency=low

  * New upstream release.
  * root-system-common: depends on fonts-freefont-otf. Thanks to
    Christophe Hugon. (Closes: #714638)

 -- Lifeng Sun <lifongsun@gmail.com>  Wed, 03 Jul 2013 18:28:49 +0800

root-system (5.34.08-1) unstable; urgency=low

  * New upstream release.
  * Bump Standards-Vesion to 3.9.4.
  * Update Vcs-* fields.
  * Remove obsolte DM-Upload-Allowed field.
  * Replace dh_pysupport with dh_python2.

 -- Lifeng Sun <lifongsun@gmail.com>  Thu, 06 Jun 2013 14:34:06 +0800

root-system (5.34.07-1) unstable; urgency=low

  * New upstream release.
  * Build-depend on libtiff-dev rather than libtiff4-dev.

 -- Lifeng Sun <lifongsun@gmail.com>  Tue, 30 Apr 2013 09:54:17 +0800

root-system (5.34.06-1~exp1) experimental; urgency=low

  * New upstream release.

 -- Lifeng Sun <lifongsun@gmail.com>  Tue, 23 Apr 2013 09:12:17 +0800

root-system (5.34.05-1~exp1) experimental; urgency=low

  * New upstream release.
  * libroot-graf2d-graf{5.34,-dev}: fix typo in package description.
    Thanks to Davide Prina. (Closes: #698522)
  * libroot-graf2d-gpad{5.34,-dev}: remove duplicated paragraphs in
    package description. Thanks to Davide Prina. (Closes: #698529)
  * Add Dutch translation. Thanks to Vincent Zweije. (Closes: #692586)
  * libroot-geom-dev: remove multi-arch support. (Closes: #693597)

 -- Lifeng Sun <lifongsun@gmail.com>  Tue, 05 Mar 2013 18:41:25 +0800

root-system (5.34.03-1~exp1) experimental; urgency=low

  * New upstream release.

 -- Lifeng Sun <lifongsun@gmail.com>  Sun, 28 Oct 2012 08:14:29 +0800

root-system (5.34.02-1~exp2) experimental; urgency=low

  * libroot-proof-dev: breaks libroot-proof-proofplayer-dev
    (<= 5.34.00-1) (Closes: #691437)

 -- Lifeng Sun <lifongsun@gmail.com>  Fri, 26 Oct 2012 07:49:46 +0800

root-system (5.34.02-1~exp1) experimental; urgency=low

  * New upstream release.

 -- Lifeng Sun <lifongsun@gmail.com>  Tue, 02 Oct 2012 11:48:19 +0800

root-system (5.34.01-1~exp1) experimental; urgency=low

  * New upstream release.
  * Remove obsolete packages: libroo-proof-clarens{5.34,-dev} and
    root-plugin-proof-peac
  * libroot-static: move libRoot.a from /usr/lib/$multiarch/root$ver/
    to /usr/lib/$multiarch/.
  * Disable builtin lzma and libAfterImage.
  * Improve ruby path detection.
  * Python binding: move Python runtime files from
    libroot-bindings-python-dev to libroot-bindings-python$ver.
  * root-system-common: update Depends field for ttf- => fonts-
    transition. (Closes: #682463)

 -- Lifeng Sun <lifongsun@gmail.com>  Mon, 23 Jul 2012 09:26:27 +0800
